Subject: [IPFIX] Question about data types of some IEs

From: Hitoshi Irino <[email-masked]>
Date: Mon, 16 Oct 2006 09:36:33 +0900

Dear all,

I have a question and suggestion about data types of some IEs.

1.
  5.5.12.  tcpHeaderLength
  Abstract Data Type: unsigned16

TCP headers has 4 bit "Data Offset" field which has the number of 32 bit
words in the TCP header. Therefore, I think TCP header max size is 2^4*4
= 64 octets. Therefore I think that unsigned8 is sufficient for this IE.
Is there any reason that is unsigned16?

2.
  5.6.9.  mplsTopLabelTTL
  Abstract Data Type: unsigned32

According to 2.1. Encoding the Label Stack in RFC3032
  0                   1                   2                   3
  0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ Label
|                Label                  | Exp |S|       TTL     | Stack
+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+ Entry

                     Label:  Label Value, 20 bits
                     Exp:    Experimental Use, 3 bits
                     S:      Bottom of Stack, 1 bit
                     TTL:    Time to Live, 8 bits

I think that unsigned8 is sufficient for this IE.
Is there any reason that is unsigned32?

3.
  5.4.30.  ipPayloadLength
  Abstract Data Type: unsigned64

totalLengthIPv4 is 16bit, payloadLengthIPv6 is 32bit for jumbo payload
(rfc2675). I think unsigned32 is sufficient for ipPayloadLength.
Why Does Abstract Data Type of this IE have unsigned64?

4.
   5.7.12.  mplsVpnRouteDistinguisher
   Abstract Data Type: octetArray

According to section 4.2 in rfc4364,
a VPN-IPv4 address consists of an 8-byte Route Distinguisher followed by 
a 4-byte IPv4 address.

Is unsigned64 sufficient for this IE?

According to page 7 of rfc4382,
MplsL3VpnRouteDistinguisher ::= TEXTUAL-CONVENTION
SYNTAX  OCTET STRING(SIZE (0..256))

I think that Abstract Data Type of this IE should be "string", if this 
IE is in conformity to rfc4382.

5.
Can Exporter implementation be chosen which use fixed or variable length 
for IEs that have octetArray or string data type?  Is it correct?
Should Information model draft define which use fixed or variable for 
these IEs?

-- 
Hitoshi Irino
NTT Network Service Systems Laboratories

_______________________________________________
IPFIX mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/ipfix